/*
 * Copyright 2000-2004 The Apache Software Foundation.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jetspeed.cps;

import org.apache.fulcrum.InitializationException;

/**
 * Services should throw this exception when an error occurs during service initialization. 
 * 
 * @author <a href="mailto:taylor@apache.org">David Sean Taylor</a>
 * @version $Id: CPSInitializationException.java,v 1.1 2004/12/27 19:36:23 taylor Exp $
 **/
public class CPSInitializationException extends InitializationException
{
    public CPSInitializationException(String error)
    {
        super(error);
    }
    
    public CPSInitializationException(String error, Throwable t)
    {
        super(error, t);
    }
    
}
