/*
 * Copyright 2000-2001,2004 The Apache Software Foundation.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jetspeed.fusion.engine.servlet;


import javax.servlet.http.HttpServletRequest;

import org.apache.jetspeed.engine.servlet.ServletRequestFactory;
import org.apache.jetspeed.engine.servlet.ServletRequestFactoryImpl;
import org.apache.pluto.om.window.PortletWindow;

/**
 * Factory implementation for creating HTTP Request Wrappers
 *
 * @author <a href="mailto:taylor@apache.org">David Sean Taylor</a>
 * @version $Id: FusionServletRequestFactoryImpl.java,v 1.1 2004/08/12 18:41:19 taylor Exp $
 */
public class FusionServletRequestFactoryImpl 
    extends ServletRequestFactoryImpl 
    implements ServletRequestFactory
{
    protected HttpServletRequest createRequest(HttpServletRequest request, PortletWindow window)
    {
        return new FusionServletRequestImpl(request, window);        
    }

}
