/* Copyright 2004 Apache Software Foundation
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/
package org.apache.jetspeed.fusion.security.impl;

import org.apache.jetspeed.om.security.JetspeedUser;
import org.apache.jetspeed.security.UserPrincipal;


/**
 * <p>The user principal for J2.</p>
 * @author <a href="mailto:taylor@apache.org">David Sean Taylor</a>
 * @version $Id: FusionUserPrincipalImpl.java,v 1.2 2004/11/08 22:41:13 taylor Exp $
 */
public class FusionUserPrincipalImpl implements UserPrincipal
{
    private String userName;
    private JetspeedUser user;
    private boolean enabled = true;
    
    public FusionUserPrincipalImpl(String userName, JetspeedUser user)
    {
        this.userName = userName;   
        this.user = user;
    }
    
    /* (non-Javadoc)
     * @see org.apache.jetspeed.security.BasePrincipal#getFullPath()
     */
    public String getFullPath()
    {
        // not supported
        return "";
    }

    /* (non-Javadoc)
     * @see java.security.Principal#getName()
     */
    public String getName()
    {
        return userName;
    }

    public JetspeedUser getUser()
    {
        return user;
    }
    
    public String toString()
    {
        return userName;
    }
    /**
     * @param enabled The enabled to set.
     */
    public void setEnabled(boolean enabled)
    {
        this.enabled = enabled;
    }
    /**
     * @return Returns the enabled.
     */
    public boolean isEnabled()
    {
        return enabled;
    }
}
