/*
 * Copyright 2000-2001,2004 The Apache Software Foundation.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jetspeed.om.registry;

/**
 * Interface describing a style option for a portlet parameter style. 
 *
 * @author <a href="mailto:mark_orciuch@ngsltd">Mark Orciuch</a>
 * @version $Id: StyleOption.java,v 1.1 2005/05/04 20:26:37 morciuch Exp $
 */
public interface StyleOption
{
	/**
	 * @return the name of this style option
	 */
	public String getName();

	/** 
	 * Sets the name of this parameter.
	 * 
	 * @param name the new parameter value
	 */
	public void setName(String value);
	
	/**
     * @return the value of this style option
     */
	public String getValue();

	/** 
	 * Sets the value of this parameter.
	 * 
	 * @param value the new parameter value
	 */
	public void setValue(String value);
}
