/*
 * Copyright 2000-2001,2004 The Apache Software Foundation.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jetspeed.om.registry.base;

import org.apache.jetspeed.om.registry.StyleOption;

/**
 * Bean like implementation of the StyleOption interface suitable for
 * Castor serialization.
 *
 * @see org.apache.jetspeed.om.registry.StyleOption
 * @author <a href="mailto:mark_orciuch@ngsltd.com">Mark Orciuch</a>
 * @version $Id: BaseStyleOption.java,v 1.1 2005/05/04 20:26:37 morciuch Exp $
 */
public class BaseStyleOption implements StyleOption
{
	private String name = null;
	private String value = null;

    /* (non-Javadoc)
     * @see org.apache.jetspeed.om.registry.StyleOption#getName()
     */
    public String getName()
    {
        return this.name;
    }

    /* (non-Javadoc)
     * @see org.apache.jetspeed.om.registry.StyleOption#setName(java.lang.String)
     */
    public void setName(String name)
    {
    	this.name = name;
    }

    /* (non-Javadoc)
     * @see org.apache.jetspeed.om.registry.StyleOption#getValue()
     */
    public String getValue()
    {
        return this.value;
    }

    /* (non-Javadoc)
     * @see org.apache.jetspeed.om.registry.StyleOption#setValue(java.lang.String)
     */
    public void setValue(String value)
    {
		this.value = value;       
    }
}
