/*
 * Copyright 2000-2004 The Apache Software Foundation.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jetspeed.portal.controls;


/**
 * This utility class is used to give information about the actions 
 *  available in a control theme template
 *
 * 
 * @author <a href="mailto:raphael@apache.org">Rapha\u00ebl Luta</a>
 *
 * @version $Id: PortletAction.java,v 1.2 2005/03/21 18:21:41 sgala Exp $
 *
 */
public class PortletAction
{
    String name = null;
    String link = null;
    String alt = null;

    /**
     * Constructor
     * 
     * @param name   Name of the action
     * @param alt    Alternative text description (localized)
     */
    public PortletAction( String name, String alt )
    {
        this.name = name;
        this.alt = alt;
    }
    
    public String getName()
    {
        return this.name;
    }
    
    public String getLink()
    {
        return this.link;
    }
    
    public void setLink(String link)
    {
        this.link = link;
    }

    public String getAlt()
    {
        return this.alt;
    }

}
