/*
 * Copyright 2004 The Apache Software Foundation.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jetspeed.services.psmlmanager;

import java.io.Serializable;

/**
 * @author <a href="mailto:jford@apache.org">Jeremy Ford</a>
 * @version $Id: PsmlMessage.java,v 1.1 2004/08/28 19:02:26 jford Exp $
 */
public class PsmlMessage implements Serializable
{
    
    public static final String REMOVE_ACTION = "remove";
    
    private String user;
    private String group;
    private String role;
    private String action;
    
    
    /**
     * @return Returns the group.
     */
    public String getGroup()
    {
        return group;
    }
    /**
     * @param group The group to set.
     */
    public void setGroup(String group)
    {
        this.group = group;
    }
    /**
     * @return Returns the role.
     */
    public String getRole()
    {
        return role;
    }
    /**
     * @param role The role to set.
     */
    public void setRole(String role)
    {
        this.role = role;
    }
    /**
     * @return Returns the user.
     */
    public String getUser()
    {
        return user;
    }
    /**
     * @param user The user to set.
     */
    public void setUser(String user)
    {
        this.user = user;
    }
    /**
     * @return Returns the action.
     */
    public String getAction()
    {
        return action;
    }
    /**
     * @param action The action to set.
     */
    public void setAction(String action)
    {
        this.action = action;
    }
}
