/*
 * Copyright 2000-2001,2004 The Apache Software Foundation.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jetspeed.services.registry;

import java.util.List;

/**
 * Interface for manipulating Hybrid registries
 *
 * @author <a href="mailto:taylor@apache.org">David Sean Taylor</a>
 * @version $Id: HybridRegistry.java,v 1.1 2004/07/14 00:50:55 taylor Exp $
 */
public interface HybridRegistry 
{

    /**
     * List of all registries managed in the database.
     */
    public List listDatabaseRegistries();

    /**
     * List of all registries managed in the file system.
     */    
    public List listFileRegistries();
}
