/*
 * Copyright 2004 The Apache Software Foundation.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jetspeed.services.registry;

import java.io.Serializable;

/**
 * @author <a href="mailto:jford@apache.org">Jeremy Ford</a>
 * @version $Id: RegistryMessage.java,v 1.1 2004/07/23 00:28:49 jford Exp $
 */
public class RegistryMessage implements Serializable
{
    public static final String ACTION_DELETE = "delete";
    public static final String ACTION_UPDATE = "update";
    public static final String ACTION_INSERT = "insert";
    public static final String ACTION_REFRESH = "refresh";
    
    private String registry;
    private String entryName;
    private String action;
    /**
     * @return Returns the action.
     */
    public String getAction()
    {
        return action;
    }
    /**
     * @param action The action to set.
     */
    public void setAction(String action)
    {
        this.action = action;
    }
    /**
     * @return Returns the entryName.
     */
    public String getEntryName()
    {
        return entryName;
    }
    /**
     * @param entryName The entryName to set.
     */
    public void setEntryName(String entryName)
    {
        this.entryName = entryName;
    }
    /**
     * @return Returns the registry.
     */
    public String getRegistry()
    {
        return registry;
    }
    /**
     * @param registry The registry to set.
     */
    public void setRegistry(String registry)
    {
        this.registry = registry;
    }
}
