/*
 * Copyright 2004 The Apache Software Foundation.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jetspeed.services.resources;



/**
 * Extends the JetspeedResources to add Fusion specific keys
 * 
 * @author <a href="mailto:jford@apache.org">Jeremy Ford</a>
 * @version $Id: FusionResources.java,v 1.2 2004/08/11 06:46:13 taylor Exp $
 */
public class FusionResources extends JetspeedResources
{
    public static final String NAVS_PIPELINE = "navs-pipeline";
    public static final String JSR168_PORTLET = "fusion.jsr168.parent";
    public static final String PORTLET_DEFINITION_PARAMETER = "fusion.jsr168.portlet_definition";
    public static final String PORTLET_APPLICATION_PARAMETER = "fusion.jsr168.portlet_application";
    public static final String J2_ENTITY = "fusion.jsr168.j2.entity";
    public static final String J1_HELP_ACTION = "fusion.jsr168.j1.help.action";
    public static final String J1_RESTORE_ACTION = "fusion.jsr168.j1.restore.action";
    public static final String J1_MINIMIZE_ACTION = "fusion.jsr168.j1.minimize.action";
    public static final String J1_MAXIMIZE_ACTION = "fusion.jsr168.j1.maximize.action";
    public static final String J1_EDIT_ACTION = "fusion.jsr168.j1.edit.action";
    public static final String J1_PRINT_ACTION = "fusion.jsr168.j1.print.action";
}
