package org.apache.jetspeed.om.dbregistry;


import java.math.BigDecimal;
import java.sql.Connection;
import java.util.ArrayList;
import java.util.Date;
import java.util.Collections;
import java.util.List;

import org.apache.commons.lang.ObjectUtils;
import org.apache.torque.TorqueException;
import org.apache.torque.om.BaseObject;
import org.apache.torque.om.ComboKey;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.Persistent;
import org.apache.torque.util.Criteria;
import org.apache.torque.util.Transaction;

  
  
/**
 * This class was autogenerated by Torque on:
 *
 * [Wed May 25 21:33:09 PDT 2005]
 *
 * You should not use this class directly.  It should not even be
 * extended all references should be to SecurityAccessDbEntry
 */
public abstract class BaseSecurityAccessDbEntry extends BaseObject
{
    /** The Peer class */
    private static final SecurityAccessDbEntryPeer peer =
        new SecurityAccessDbEntryPeer();

        
    /** The value for the id field */
    private long id;
      
    /** The value for the action field */
    private String action;
      
    /** The value for the entryId field */
    private long entryId;
  
    
    /**
     * Get the Id
     *
     * @return long
     */
    public long getId()
    {
        return id;
    }

                                              
    /**
     * Set the value of Id
     *
     * @param v new value
     */
    public void setId(long v) throws TorqueException
    {
    
                  if (this.id != v)
              {
            this.id = v;
            setModified(true);
        }
    
          
                                  
        // update associated SecurityAllowDbEntry
        if (collSecurityAllowDbEntrys != null)
        {
            for (int i = 0; i < collSecurityAllowDbEntrys.size(); i++)
            {
                ((SecurityAllowDbEntry) collSecurityAllowDbEntrys.get(i))
                    .setAccessId(v);
            }
        }
                      }
  
    /**
     * Get the Action
     *
     * @return String
     */
    public String getAction()
    {
        return action;
    }

                        
    /**
     * Set the value of Action
     *
     * @param v new value
     */
    public void setAction(String v) 
    {
    
                  if (!ObjectUtils.equals(this.action, v))
              {
            this.action = v;
            setModified(true);
        }
    
          
              }
  
    /**
     * Get the EntryId
     *
     * @return long
     */
    public long getEntryId()
    {
        return entryId;
    }

                              
    /**
     * Set the value of EntryId
     *
     * @param v new value
     */
    public void setEntryId(long v) throws TorqueException
    {
    
                  if (this.entryId != v)
              {
            this.entryId = v;
            setModified(true);
        }
    
                          
                if (aSecurityDbEntry != null && !(aSecurityDbEntry.getId() == v))
                {
            aSecurityDbEntry = null;
        }
      
              }
  
      
    
                  
    
        private SecurityDbEntry aSecurityDbEntry;

    /**
     * Declares an association between this object and a SecurityDbEntry object
     *
     * @param v SecurityDbEntry
     * @throws TorqueException
     */
    public void setSecurityDbEntry(SecurityDbEntry v) throws TorqueException
    {
            if (v == null)
        {
                    setEntryId(0);
                  }
        else
        {
            setEntryId(v.getId());
        }
                aSecurityDbEntry = v;
    }

                                            
    /**
     * Get the associated SecurityDbEntry object
     *
     * @return the associated SecurityDbEntry object
     * @throws TorqueException
     */
    public SecurityDbEntry getSecurityDbEntry() throws TorqueException
    {
        if (aSecurityDbEntry == null && (this.entryId > 0))
        {
                          aSecurityDbEntry = SecurityDbEntryPeer.retrieveByPK(SimpleKey.keyFor(this.entryId));
              
            /* The following can be used instead of the line above to
               guarantee the related object contains a reference
               to this object, but this level of coupling
               may be undesirable in many circumstances.
               As it can lead to a db query with many results that may
               never be used.
               SecurityDbEntry obj = SecurityDbEntryPeer.retrieveByPK(this.entryId);
               obj.addSecurityAccessDbEntrys(this);
            */
        }
        return aSecurityDbEntry;
    }

    /**
     * Provides convenient way to set a relationship based on a
     * ObjectKey.  e.g.
     * <code>bar.setFooKey(foo.getPrimaryKey())</code>
     *
           */
    public void setSecurityDbEntryKey(ObjectKey key) throws TorqueException
    {
      
                        setEntryId(((NumberKey) key).longValue());
                  }
       
                                
            
    /**
     * Collection to store aggregation of collSecurityAllowDbEntrys
     */
    protected List collSecurityAllowDbEntrys;

    /**
     * Temporary storage of collSecurityAllowDbEntrys to save a possible db hit in
     * the event objects are add to the collection, but the
     * complete collection is never requested.
     */
    protected void initSecurityAllowDbEntrys()
    {
        if (collSecurityAllowDbEntrys == null)
        {
            collSecurityAllowDbEntrys = new ArrayList();
        }
    }

    /**
     * Method called to associate a SecurityAllowDbEntry object to this object
     * through the SecurityAllowDbEntry foreign key attribute
     *
     * @param l SecurityAllowDbEntry
     * @throws TorqueException
     */
    public void addSecurityAllowDbEntry(SecurityAllowDbEntry l) throws TorqueException
    {
        getSecurityAllowDbEntrys().add(l);
        l.setSecurityAccessDbEntry((SecurityAccessDbEntry) this);
    }

    /**
     * The criteria used to select the current contents of collSecurityAllowDbEntrys
     */
    private Criteria lastSecurityAllowDbEntrysCriteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getSecurityAllowDbEntrys(new Criteria())
     *
     * @throws TorqueException
     */
    public List getSecurityAllowDbEntrys() throws TorqueException
    {
        if (collSecurityAllowDbEntrys == null)
        {
            collSecurityAllowDbEntrys = getSecurityAllowDbEntrys(new Criteria(10));
        }
        return collSecurityAllowDbEntrys;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this SecurityAccessDbEntry has previously
     * been saved, it will retrieve related SecurityAllowDbEntrys from storage.
     * If this SecurityAccessDbEntry is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List getSecurityAllowDbEntrys(Criteria criteria) throws TorqueException
    {
        if (collSecurityAllowDbEntrys == null)
        {
            if (isNew())
            {
               collSecurityAllowDbEntrys = new ArrayList();
            }
            else
            {
                      criteria.add(SecurityAllowDbEntryPeer.ACCESS_ID, getId() );
                      collSecurityAllowDbEntrys = SecurityAllowDbEntryPeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                      criteria.add(SecurityAllowDbEntryPeer.ACCESS_ID, getId());
                      if (!lastSecurityAllowDbEntrysCriteria.equals(criteria))
                {
                    collSecurityAllowDbEntrys = SecurityAllowDbEntryPeer.doSelect(criteria);
                }
            }
        }
        lastSecurityAllowDbEntrysCriteria = criteria;

        return collSecurityAllowDbEntrys;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getSecurityAllowDbEntrys(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List getSecurityAllowDbEntrys(Connection con) throws TorqueException
    {
        if (collSecurityAllowDbEntrys == null)
        {
            collSecurityAllowDbEntrys = getSecurityAllowDbEntrys(new Criteria(10), con);
        }
        return collSecurityAllowDbEntrys;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this SecurityAccessDbEntry has previously
     * been saved, it will retrieve related SecurityAllowDbEntrys from storage.
     * If this SecurityAccessDbEntry is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List getSecurityAllowDbEntrys(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collSecurityAllowDbEntrys == null)
        {
            if (isNew())
            {
               collSecurityAllowDbEntrys = new ArrayList();
            }
            else
            {
                       criteria.add(SecurityAllowDbEntryPeer.ACCESS_ID, getId());
                       collSecurityAllowDbEntrys = SecurityAllowDbEntryPeer.doSelect(criteria, con);
             }
         }
         else
         {
             // criteria has no effect for a new object
             if (!isNew())
             {
                 // the following code is to determine if a new query is
                 // called for.  If the criteria is the same as the last
                 // one, just return the collection.
                       criteria.add(SecurityAllowDbEntryPeer.ACCESS_ID, getId());
                       if (!lastSecurityAllowDbEntrysCriteria.equals(criteria))
                 {
                     collSecurityAllowDbEntrys = SecurityAllowDbEntryPeer.doSelect(criteria, con);
                 }
             }
         }
         lastSecurityAllowDbEntrysCriteria = criteria;

         return collSecurityAllowDbEntrys;
     }

                  
              
                    
                              
                                
                                                              
                                        
                    
                    
          
    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this SecurityAccessDbEntry is new, it will return
     * an empty collection; or if this SecurityAccessDbEntry has previously
     * been saved, it will retrieve related SecurityAllowDbEntrys from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in SecurityAccessDbEntry.
     */
    protected List getSecurityAllowDbEntrysJoinSecurityAccessDbEntry(Criteria criteria)
        throws TorqueException
    {
        if (collSecurityAllowDbEntrys == null)
        {
            if (isNew())
            {
               collSecurityAllowDbEntrys = new ArrayList();
            }
            else
            {
                            criteria.add(SecurityAllowDbEntryPeer.ACCESS_ID, getId());
                            collSecurityAllowDbEntrys = SecurityAllowDbEntryPeer.doSelectJoinSecurityAccessDbEntry(criteria);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            boolean newCriteria = true;
                        criteria.add(SecurityAllowDbEntryPeer.ACCESS_ID, getId());
                        if (!lastSecurityAllowDbEntrysCriteria.equals(criteria))
            {
                collSecurityAllowDbEntrys = SecurityAllowDbEntryPeer.doSelectJoinSecurityAccessDbEntry(criteria);
            }
        }
        lastSecurityAllowDbEntrysCriteria = criteria;

        return collSecurityAllowDbEntrys;
    }
                            


          
    private static List fieldNames = null;

    /**
     * Generate a list of field names.
     *
     * @return a list of field names
     */
    public static synchronized List getFieldNames()
    {
        if (fieldNames == null)
        {
            fieldNames = new ArrayList();
              fieldNames.add("Id");
              fieldNames.add("Action");
              fieldNames.add("EntryId");
              fieldNames = Collections.unmodifiableList(fieldNames);
        }
        return fieldNames;
    }

    /**
     * Retrieves a field from the object by name passed in as a String.
     *
     * @param name field name
     * @return value
     */
    public Object getByName(String name)
    {
          if (name.equals("Id"))
        {
                return new Long(getId());
            }
          if (name.equals("Action"))
        {
                return getAction();
            }
          if (name.equals("EntryId"))
        {
                return new Long(getEntryId());
            }
          return null;
    }
    
    /**
     * Retrieves a field from the object by name passed in
     * as a String.  The String must be one of the static
     * Strings defined in this Class' Peer.
     *
     * @param name peer name
     * @return value
     */
    public Object getByPeerName(String name)
    {
          if (name.equals(SecurityAccessDbEntryPeer.ID))
        {
                return new Long(getId());
            }
          if (name.equals(SecurityAccessDbEntryPeer.ACTION))
        {
                return getAction();
            }
          if (name.equals(SecurityAccessDbEntryPeer.ENTRY_ID))
        {
                return new Long(getEntryId());
            }
          return null;
    }

    /**
     * Retrieves a field from the object by Position as specified
     * in the xml schema.  Zero-based.
     *
     * @param pos position in xml schema
     * @return value
     */
    public Object getByPosition(int pos)
    {
            if (pos == 0)
        {
                return new Long(getId());
            }
              if (pos == 1)
        {
                return getAction();
            }
              if (pos == 2)
        {
                return new Long(getEntryId());
            }
              return null;
    }
     
    /**
     * Stores the object in the database.  If the object is new,
     * it inserts it; otherwise an update is performed.
     *
     * @throws Exception
     */
    public void save() throws Exception
    {
          save(SecurityAccessDbEntryPeer.getMapBuilder()
                .getDatabaseMap().getName());
      }

    /**
     * Stores the object in the database.  If the object is new,
     * it inserts it; otherwise an update is performed.
       * Note: this code is here because the method body is
     * auto-generated conditionally and therefore needs to be
     * in this file instead of in the super class, BaseObject.
       *
     * @param dbName
     * @throws TorqueException
     */
    public void save(String dbName) throws TorqueException
    {
        Connection con = null;
          try
        {
            con = Transaction.begin(dbName);
            save(con);
            Transaction.commit(con);
        }
        catch(TorqueException e)
        {
            Transaction.safeRollback(con);
            throw e;
        }
      }

      /** flag to prevent endless save loop, if this object is referenced
        by another object which falls in this transaction. */
    private boolean alreadyInSave = false;
      /**
     * Stores the object in the database.  If the object is new,
     * it inserts it; otherwise an update is performed.  This method
     * is meant to be used as part of a transaction, otherwise use
     * the save() method and the connection details will be handled
     * internally
     *
     * @param con
     * @throws TorqueException
     */
    public void save(Connection con) throws TorqueException
    {
          if (!alreadyInSave)
        {
            alreadyInSave = true;


  
            // If this object has been modified, then save it to the database.
            if (isModified())
            {
                if (isNew())
                {
                    SecurityAccessDbEntryPeer.doInsert((SecurityAccessDbEntry) this, con);
                    setNew(false);
                }
                else
                {
                    SecurityAccessDbEntryPeer.doUpdate((SecurityAccessDbEntry) this, con);
                }
            }

                                      
                
            if (collSecurityAllowDbEntrys != null)
            {
                for (int i = 0; i < collSecurityAllowDbEntrys.size(); i++)
                {
                    ((SecurityAllowDbEntry) collSecurityAllowDbEntrys.get(i)).save(con);
                }
            }
                          alreadyInSave = false;
        }
      }


                          
      /**
     * Set the PrimaryKey using ObjectKey.
     *
     * @param  id ObjectKey
     */
    public void setPrimaryKey(ObjectKey key)
        throws TorqueException
    {
            setId(((NumberKey) key).longValue());
        }

    /**
     * Set the PrimaryKey using a String.
     *
     * @param key
     */
    public void setPrimaryKey(String key) throws TorqueException
    {
            setId(Long.parseLong(key));
        }

  
    /**
     * returns an id that differentiates this object from others
     * of its class.
     */
    public ObjectKey getPrimaryKey()
    {
          return SimpleKey.keyFor(getId());
      }

 

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
       * It then fills all the association collections and sets the
     * related objects to isNew=true.
       */
      public SecurityAccessDbEntry copy() throws TorqueException
    {
        return copyInto(new SecurityAccessDbEntry());
    }
  
    protected SecurityAccessDbEntry copyInto(SecurityAccessDbEntry copyObj) throws TorqueException
    {
          copyObj.setId(id);
          copyObj.setAction(action);
          copyObj.setEntryId(entryId);
  
                    copyObj.setId(0);
                        
                                      
                
        List v = getSecurityAllowDbEntrys();
        for (int i = 0; i < v.size(); i++)
        {
            SecurityAllowDbEntry obj = (SecurityAllowDbEntry) v.get(i);
            copyObj.addSecurityAllowDbEntry(obj.copy());
        }
                    
        return copyObj;
    }

    /**
     * returns a peer instance associated with this om.  Since Peer classes
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     */
    public SecurityAccessDbEntryPeer getPeer()
    {
        return peer;
    }

    public String toString()
    {
        StringBuffer str = new StringBuffer();
        str.append("SecurityAccessDbEntry:\n");
        str.append("Id = ")
           .append(getId())
           .append("\n");
        str.append("Action = ")
           .append(getAction())
           .append("\n");
        str.append("EntryId = ")
           .append(getEntryId())
           .append("\n");
        return(str.toString());
    }
}
