package org.apache.jetspeed.om.dbregistry;


import java.math.BigDecimal;
import java.sql.Connection;
import java.util.ArrayList;
import java.util.Date;
import java.util.Collections;
import java.util.List;

import org.apache.commons.lang.ObjectUtils;
import org.apache.torque.TorqueException;
import org.apache.torque.om.BaseObject;
import org.apache.torque.om.ComboKey;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.Persistent;
import org.apache.torque.util.Criteria;
import org.apache.torque.util.Transaction;

  
  
/**
 * This class was autogenerated by Torque on:
 *
 * [Wed May 25 21:33:09 PDT 2005]
 *
 * You should not use this class directly.  It should not even be
 * extended all references should be to SecurityAllowDbEntry
 */
public abstract class BaseSecurityAllowDbEntry extends BaseObject
{
    /** The Peer class */
    private static final SecurityAllowDbEntryPeer peer =
        new SecurityAllowDbEntryPeer();

        
    /** The value for the id field */
    private long id;
      
    /** The value for the allowType field */
    private String allowType;
      
    /** The value for the allowValue field */
    private String allowValue;
      
    /** The value for the allowGroup field */
    private String allowGroup;
      
    /** The value for the accessId field */
    private long accessId;
  
    
    /**
     * Get the Id
     *
     * @return long
     */
    public long getId()
    {
        return id;
    }

                        
    /**
     * Set the value of Id
     *
     * @param v new value
     */
    public void setId(long v) 
    {
    
                  if (this.id != v)
              {
            this.id = v;
            setModified(true);
        }
    
          
              }
  
    /**
     * Get the AllowType
     *
     * @return String
     */
    public String getAllowType()
    {
        return allowType;
    }

                        
    /**
     * Set the value of AllowType
     *
     * @param v new value
     */
    public void setAllowType(String v) 
    {
    
                  if (!ObjectUtils.equals(this.allowType, v))
              {
            this.allowType = v;
            setModified(true);
        }
    
          
              }
  
    /**
     * Get the AllowValue
     *
     * @return String
     */
    public String getAllowValue()
    {
        return allowValue;
    }

                        
    /**
     * Set the value of AllowValue
     *
     * @param v new value
     */
    public void setAllowValue(String v) 
    {
    
                  if (!ObjectUtils.equals(this.allowValue, v))
              {
            this.allowValue = v;
            setModified(true);
        }
    
          
              }
  
    /**
     * Get the AllowGroup
     *
     * @return String
     */
    public String getAllowGroup()
    {
        return allowGroup;
    }

                        
    /**
     * Set the value of AllowGroup
     *
     * @param v new value
     */
    public void setAllowGroup(String v) 
    {
    
                  if (!ObjectUtils.equals(this.allowGroup, v))
              {
            this.allowGroup = v;
            setModified(true);
        }
    
          
              }
  
    /**
     * Get the AccessId
     *
     * @return long
     */
    public long getAccessId()
    {
        return accessId;
    }

                              
    /**
     * Set the value of AccessId
     *
     * @param v new value
     */
    public void setAccessId(long v) throws TorqueException
    {
    
                  if (this.accessId != v)
              {
            this.accessId = v;
            setModified(true);
        }
    
                          
                if (aSecurityAccessDbEntry != null && !(aSecurityAccessDbEntry.getId() == v))
                {
            aSecurityAccessDbEntry = null;
        }
      
              }
  
      
    
                  
    
        private SecurityAccessDbEntry aSecurityAccessDbEntry;

    /**
     * Declares an association between this object and a SecurityAccessDbEntry object
     *
     * @param v SecurityAccessDbEntry
     * @throws TorqueException
     */
    public void setSecurityAccessDbEntry(SecurityAccessDbEntry v) throws TorqueException
    {
            if (v == null)
        {
                    setAccessId(0);
                  }
        else
        {
            setAccessId(v.getId());
        }
                aSecurityAccessDbEntry = v;
    }

                                            
    /**
     * Get the associated SecurityAccessDbEntry object
     *
     * @return the associated SecurityAccessDbEntry object
     * @throws TorqueException
     */
    public SecurityAccessDbEntry getSecurityAccessDbEntry() throws TorqueException
    {
        if (aSecurityAccessDbEntry == null && (this.accessId > 0))
        {
                          aSecurityAccessDbEntry = SecurityAccessDbEntryPeer.retrieveByPK(SimpleKey.keyFor(this.accessId));
              
            /* The following can be used instead of the line above to
               guarantee the related object contains a reference
               to this object, but this level of coupling
               may be undesirable in many circumstances.
               As it can lead to a db query with many results that may
               never be used.
               SecurityAccessDbEntry obj = SecurityAccessDbEntryPeer.retrieveByPK(this.accessId);
               obj.addSecurityAllowDbEntrys(this);
            */
        }
        return aSecurityAccessDbEntry;
    }

    /**
     * Provides convenient way to set a relationship based on a
     * ObjectKey.  e.g.
     * <code>bar.setFooKey(foo.getPrimaryKey())</code>
     *
           */
    public void setSecurityAccessDbEntryKey(ObjectKey key) throws TorqueException
    {
      
                        setAccessId(((NumberKey) key).longValue());
                  }
       
                
    private static List fieldNames = null;

    /**
     * Generate a list of field names.
     *
     * @return a list of field names
     */
    public static synchronized List getFieldNames()
    {
        if (fieldNames == null)
        {
            fieldNames = new ArrayList();
              fieldNames.add("Id");
              fieldNames.add("AllowType");
              fieldNames.add("AllowValue");
              fieldNames.add("AllowGroup");
              fieldNames.add("AccessId");
              fieldNames = Collections.unmodifiableList(fieldNames);
        }
        return fieldNames;
    }

    /**
     * Retrieves a field from the object by name passed in as a String.
     *
     * @param name field name
     * @return value
     */
    public Object getByName(String name)
    {
          if (name.equals("Id"))
        {
                return new Long(getId());
            }
          if (name.equals("AllowType"))
        {
                return getAllowType();
            }
          if (name.equals("AllowValue"))
        {
                return getAllowValue();
            }
          if (name.equals("AllowGroup"))
        {
                return getAllowGroup();
            }
          if (name.equals("AccessId"))
        {
                return new Long(getAccessId());
            }
          return null;
    }
    
    /**
     * Retrieves a field from the object by name passed in
     * as a String.  The String must be one of the static
     * Strings defined in this Class' Peer.
     *
     * @param name peer name
     * @return value
     */
    public Object getByPeerName(String name)
    {
          if (name.equals(SecurityAllowDbEntryPeer.ID))
        {
                return new Long(getId());
            }
          if (name.equals(SecurityAllowDbEntryPeer.ALLOW_TYPE))
        {
                return getAllowType();
            }
          if (name.equals(SecurityAllowDbEntryPeer.ALLOW_VALUE))
        {
                return getAllowValue();
            }
          if (name.equals(SecurityAllowDbEntryPeer.ALLOW_GROUP))
        {
                return getAllowGroup();
            }
          if (name.equals(SecurityAllowDbEntryPeer.ACCESS_ID))
        {
                return new Long(getAccessId());
            }
          return null;
    }

    /**
     * Retrieves a field from the object by Position as specified
     * in the xml schema.  Zero-based.
     *
     * @param pos position in xml schema
     * @return value
     */
    public Object getByPosition(int pos)
    {
            if (pos == 0)
        {
                return new Long(getId());
            }
              if (pos == 1)
        {
                return getAllowType();
            }
              if (pos == 2)
        {
                return getAllowValue();
            }
              if (pos == 3)
        {
                return getAllowGroup();
            }
              if (pos == 4)
        {
                return new Long(getAccessId());
            }
              return null;
    }
     
    /**
     * Stores the object in the database.  If the object is new,
     * it inserts it; otherwise an update is performed.
     *
     * @throws Exception
     */
    public void save() throws Exception
    {
          save(SecurityAllowDbEntryPeer.getMapBuilder()
                .getDatabaseMap().getName());
      }

    /**
     * Stores the object in the database.  If the object is new,
     * it inserts it; otherwise an update is performed.
       * Note: this code is here because the method body is
     * auto-generated conditionally and therefore needs to be
     * in this file instead of in the super class, BaseObject.
       *
     * @param dbName
     * @throws TorqueException
     */
    public void save(String dbName) throws TorqueException
    {
        Connection con = null;
          try
        {
            con = Transaction.begin(dbName);
            save(con);
            Transaction.commit(con);
        }
        catch(TorqueException e)
        {
            Transaction.safeRollback(con);
            throw e;
        }
      }

      /** flag to prevent endless save loop, if this object is referenced
        by another object which falls in this transaction. */
    private boolean alreadyInSave = false;
      /**
     * Stores the object in the database.  If the object is new,
     * it inserts it; otherwise an update is performed.  This method
     * is meant to be used as part of a transaction, otherwise use
     * the save() method and the connection details will be handled
     * internally
     *
     * @param con
     * @throws TorqueException
     */
    public void save(Connection con) throws TorqueException
    {
          if (!alreadyInSave)
        {
            alreadyInSave = true;


  
            // If this object has been modified, then save it to the database.
            if (isModified())
            {
                if (isNew())
                {
                    SecurityAllowDbEntryPeer.doInsert((SecurityAllowDbEntry) this, con);
                    setNew(false);
                }
                else
                {
                    SecurityAllowDbEntryPeer.doUpdate((SecurityAllowDbEntry) this, con);
                }
            }

                      alreadyInSave = false;
        }
      }


                    
      /**
     * Set the PrimaryKey using ObjectKey.
     *
     * @param  id ObjectKey
     */
    public void setPrimaryKey(ObjectKey key)
        
    {
            setId(((NumberKey) key).longValue());
        }

    /**
     * Set the PrimaryKey using a String.
     *
     * @param key
     */
    public void setPrimaryKey(String key) 
    {
            setId(Long.parseLong(key));
        }

  
    /**
     * returns an id that differentiates this object from others
     * of its class.
     */
    public ObjectKey getPrimaryKey()
    {
          return SimpleKey.keyFor(getId());
      }

 

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
       * It then fills all the association collections and sets the
     * related objects to isNew=true.
       */
      public SecurityAllowDbEntry copy() throws TorqueException
    {
        return copyInto(new SecurityAllowDbEntry());
    }
  
    protected SecurityAllowDbEntry copyInto(SecurityAllowDbEntry copyObj) throws TorqueException
    {
          copyObj.setId(id);
          copyObj.setAllowType(allowType);
          copyObj.setAllowValue(allowValue);
          copyObj.setAllowGroup(allowGroup);
          copyObj.setAccessId(accessId);
  
                    copyObj.setId(0);
                                    
        
        return copyObj;
    }

    /**
     * returns a peer instance associated with this om.  Since Peer classes
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     */
    public SecurityAllowDbEntryPeer getPeer()
    {
        return peer;
    }

    public String toString()
    {
        StringBuffer str = new StringBuffer();
        str.append("SecurityAllowDbEntry:\n");
        str.append("Id = ")
           .append(getId())
           .append("\n");
        str.append("AllowType = ")
           .append(getAllowType())
           .append("\n");
        str.append("AllowValue = ")
           .append(getAllowValue())
           .append("\n");
        str.append("AllowGroup = ")
           .append(getAllowGroup())
           .append("\n");
        str.append("AccessId = ")
           .append(getAccessId())
           .append("\n");
        return(str.toString());
    }
}
