package org.apache.jetspeed.om.dbregistry;


import java.math.BigDecimal;
import java.sql.Connection;
import java.util.ArrayList;
import java.util.Date;
import java.util.Collections;
import java.util.List;

import org.apache.commons.lang.ObjectUtils;
import org.apache.torque.TorqueException;
import org.apache.torque.om.BaseObject;
import org.apache.torque.om.ComboKey;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.Persistent;
import org.apache.torque.util.Criteria;
import org.apache.torque.util.Transaction;


/**
 * This class was autogenerated by Torque on:
 *
 * [Wed May 25 21:33:09 PDT 2005]
 *
 * You should not use this class directly.  It should not even be
 * extended all references should be to SecurityDbEntry
 */
public abstract class BaseSecurityDbEntry extends BaseObject
{
    /** The Peer class */
    private static final SecurityDbEntryPeer peer =
        new SecurityDbEntryPeer();

        
    /** The value for the id field */
    private long id;
      
    /** The value for the name field */
    private String name;
      
    /** The value for the title field */
    private String title;
      
    /** The value for the description field */
    private String description;
  
    
    /**
     * Get the Id
     *
     * @return long
     */
    public long getId()
    {
        return id;
    }

                                              
    /**
     * Set the value of Id
     *
     * @param v new value
     */
    public void setId(long v) throws TorqueException
    {
    
                  if (this.id != v)
              {
            this.id = v;
            setModified(true);
        }
    
          
                                  
        // update associated SecurityAccessDbEntry
        if (collSecurityAccessDbEntrys != null)
        {
            for (int i = 0; i < collSecurityAccessDbEntrys.size(); i++)
            {
                ((SecurityAccessDbEntry) collSecurityAccessDbEntrys.get(i))
                    .setEntryId(v);
            }
        }
                      }
  
    /**
     * Get the Name
     *
     * @return String
     */
    public String getName()
    {
        return name;
    }

                        
    /**
     * Set the value of Name
     *
     * @param v new value
     */
    public void setName(String v) 
    {
    
                  if (!ObjectUtils.equals(this.name, v))
              {
            this.name = v;
            setModified(true);
        }
    
          
              }
  
    /**
     * Get the Title
     *
     * @return String
     */
    public String getTitle()
    {
        return title;
    }

                        
    /**
     * Set the value of Title
     *
     * @param v new value
     */
    public void setTitle(String v) 
    {
    
                  if (!ObjectUtils.equals(this.title, v))
              {
            this.title = v;
            setModified(true);
        }
    
          
              }
  
    /**
     * Get the Description
     *
     * @return String
     */
    public String getDescription()
    {
        return description;
    }

                        
    /**
     * Set the value of Description
     *
     * @param v new value
     */
    public void setDescription(String v) 
    {
    
                  if (!ObjectUtils.equals(this.description, v))
              {
            this.description = v;
            setModified(true);
        }
    
          
              }
  
         
                                
            
    /**
     * Collection to store aggregation of collSecurityAccessDbEntrys
     */
    protected List collSecurityAccessDbEntrys;

    /**
     * Temporary storage of collSecurityAccessDbEntrys to save a possible db hit in
     * the event objects are add to the collection, but the
     * complete collection is never requested.
     */
    protected void initSecurityAccessDbEntrys()
    {
        if (collSecurityAccessDbEntrys == null)
        {
            collSecurityAccessDbEntrys = new ArrayList();
        }
    }

    /**
     * Method called to associate a SecurityAccessDbEntry object to this object
     * through the SecurityAccessDbEntry foreign key attribute
     *
     * @param l SecurityAccessDbEntry
     * @throws TorqueException
     */
    public void addSecurityAccessDbEntry(SecurityAccessDbEntry l) throws TorqueException
    {
        getSecurityAccessDbEntrys().add(l);
        l.setSecurityDbEntry((SecurityDbEntry) this);
    }

    /**
     * The criteria used to select the current contents of collSecurityAccessDbEntrys
     */
    private Criteria lastSecurityAccessDbEntrysCriteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getSecurityAccessDbEntrys(new Criteria())
     *
     * @throws TorqueException
     */
    public List getSecurityAccessDbEntrys() throws TorqueException
    {
        if (collSecurityAccessDbEntrys == null)
        {
            collSecurityAccessDbEntrys = getSecurityAccessDbEntrys(new Criteria(10));
        }
        return collSecurityAccessDbEntrys;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this SecurityDbEntry has previously
     * been saved, it will retrieve related SecurityAccessDbEntrys from storage.
     * If this SecurityDbEntry is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List getSecurityAccessDbEntrys(Criteria criteria) throws TorqueException
    {
        if (collSecurityAccessDbEntrys == null)
        {
            if (isNew())
            {
               collSecurityAccessDbEntrys = new ArrayList();
            }
            else
            {
                      criteria.add(SecurityAccessDbEntryPeer.ENTRY_ID, getId() );
                      collSecurityAccessDbEntrys = SecurityAccessDbEntryPeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                      criteria.add(SecurityAccessDbEntryPeer.ENTRY_ID, getId());
                      if (!lastSecurityAccessDbEntrysCriteria.equals(criteria))
                {
                    collSecurityAccessDbEntrys = SecurityAccessDbEntryPeer.doSelect(criteria);
                }
            }
        }
        lastSecurityAccessDbEntrysCriteria = criteria;

        return collSecurityAccessDbEntrys;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getSecurityAccessDbEntrys(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List getSecurityAccessDbEntrys(Connection con) throws TorqueException
    {
        if (collSecurityAccessDbEntrys == null)
        {
            collSecurityAccessDbEntrys = getSecurityAccessDbEntrys(new Criteria(10), con);
        }
        return collSecurityAccessDbEntrys;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this SecurityDbEntry has previously
     * been saved, it will retrieve related SecurityAccessDbEntrys from storage.
     * If this SecurityDbEntry is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List getSecurityAccessDbEntrys(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collSecurityAccessDbEntrys == null)
        {
            if (isNew())
            {
               collSecurityAccessDbEntrys = new ArrayList();
            }
            else
            {
                       criteria.add(SecurityAccessDbEntryPeer.ENTRY_ID, getId());
                       collSecurityAccessDbEntrys = SecurityAccessDbEntryPeer.doSelect(criteria, con);
             }
         }
         else
         {
             // criteria has no effect for a new object
             if (!isNew())
             {
                 // the following code is to determine if a new query is
                 // called for.  If the criteria is the same as the last
                 // one, just return the collection.
                       criteria.add(SecurityAccessDbEntryPeer.ENTRY_ID, getId());
                       if (!lastSecurityAccessDbEntrysCriteria.equals(criteria))
                 {
                     collSecurityAccessDbEntrys = SecurityAccessDbEntryPeer.doSelect(criteria, con);
                 }
             }
         }
         lastSecurityAccessDbEntrysCriteria = criteria;

         return collSecurityAccessDbEntrys;
     }

                  
              
                    
                              
                                
                                                              
                                        
                    
                    
          
    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this SecurityDbEntry is new, it will return
     * an empty collection; or if this SecurityDbEntry has previously
     * been saved, it will retrieve related SecurityAccessDbEntrys from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in SecurityDbEntry.
     */
    protected List getSecurityAccessDbEntrysJoinSecurityDbEntry(Criteria criteria)
        throws TorqueException
    {
        if (collSecurityAccessDbEntrys == null)
        {
            if (isNew())
            {
               collSecurityAccessDbEntrys = new ArrayList();
            }
            else
            {
                            criteria.add(SecurityAccessDbEntryPeer.ENTRY_ID, getId());
                            collSecurityAccessDbEntrys = SecurityAccessDbEntryPeer.doSelectJoinSecurityDbEntry(criteria);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            boolean newCriteria = true;
                        criteria.add(SecurityAccessDbEntryPeer.ENTRY_ID, getId());
                        if (!lastSecurityAccessDbEntrysCriteria.equals(criteria))
            {
                collSecurityAccessDbEntrys = SecurityAccessDbEntryPeer.doSelectJoinSecurityDbEntry(criteria);
            }
        }
        lastSecurityAccessDbEntrysCriteria = criteria;

        return collSecurityAccessDbEntrys;
    }
                            


          
    private static List fieldNames = null;

    /**
     * Generate a list of field names.
     *
     * @return a list of field names
     */
    public static synchronized List getFieldNames()
    {
        if (fieldNames == null)
        {
            fieldNames = new ArrayList();
              fieldNames.add("Id");
              fieldNames.add("Name");
              fieldNames.add("Title");
              fieldNames.add("Description");
              fieldNames = Collections.unmodifiableList(fieldNames);
        }
        return fieldNames;
    }

    /**
     * Retrieves a field from the object by name passed in as a String.
     *
     * @param name field name
     * @return value
     */
    public Object getByName(String name)
    {
          if (name.equals("Id"))
        {
                return new Long(getId());
            }
          if (name.equals("Name"))
        {
                return getName();
            }
          if (name.equals("Title"))
        {
                return getTitle();
            }
          if (name.equals("Description"))
        {
                return getDescription();
            }
          return null;
    }
    
    /**
     * Retrieves a field from the object by name passed in
     * as a String.  The String must be one of the static
     * Strings defined in this Class' Peer.
     *
     * @param name peer name
     * @return value
     */
    public Object getByPeerName(String name)
    {
          if (name.equals(SecurityDbEntryPeer.ID))
        {
                return new Long(getId());
            }
          if (name.equals(SecurityDbEntryPeer.NAME))
        {
                return getName();
            }
          if (name.equals(SecurityDbEntryPeer.TITLE))
        {
                return getTitle();
            }
          if (name.equals(SecurityDbEntryPeer.DESCRIPTION))
        {
                return getDescription();
            }
          return null;
    }

    /**
     * Retrieves a field from the object by Position as specified
     * in the xml schema.  Zero-based.
     *
     * @param pos position in xml schema
     * @return value
     */
    public Object getByPosition(int pos)
    {
            if (pos == 0)
        {
                return new Long(getId());
            }
              if (pos == 1)
        {
                return getName();
            }
              if (pos == 2)
        {
                return getTitle();
            }
              if (pos == 3)
        {
                return getDescription();
            }
              return null;
    }
     
    /**
     * Stores the object in the database.  If the object is new,
     * it inserts it; otherwise an update is performed.
     *
     * @throws Exception
     */
    public void save() throws Exception
    {
          save(SecurityDbEntryPeer.getMapBuilder()
                .getDatabaseMap().getName());
      }

    /**
     * Stores the object in the database.  If the object is new,
     * it inserts it; otherwise an update is performed.
       * Note: this code is here because the method body is
     * auto-generated conditionally and therefore needs to be
     * in this file instead of in the super class, BaseObject.
       *
     * @param dbName
     * @throws TorqueException
     */
    public void save(String dbName) throws TorqueException
    {
        Connection con = null;
          try
        {
            con = Transaction.begin(dbName);
            save(con);
            Transaction.commit(con);
        }
        catch(TorqueException e)
        {
            Transaction.safeRollback(con);
            throw e;
        }
      }

      /** flag to prevent endless save loop, if this object is referenced
        by another object which falls in this transaction. */
    private boolean alreadyInSave = false;
      /**
     * Stores the object in the database.  If the object is new,
     * it inserts it; otherwise an update is performed.  This method
     * is meant to be used as part of a transaction, otherwise use
     * the save() method and the connection details will be handled
     * internally
     *
     * @param con
     * @throws TorqueException
     */
    public void save(Connection con) throws TorqueException
    {
          if (!alreadyInSave)
        {
            alreadyInSave = true;


  
            // If this object has been modified, then save it to the database.
            if (isModified())
            {
                if (isNew())
                {
                    SecurityDbEntryPeer.doInsert((SecurityDbEntry) this, con);
                    setNew(false);
                }
                else
                {
                    SecurityDbEntryPeer.doUpdate((SecurityDbEntry) this, con);
                }
            }

                                      
                
            if (collSecurityAccessDbEntrys != null)
            {
                for (int i = 0; i < collSecurityAccessDbEntrys.size(); i++)
                {
                    ((SecurityAccessDbEntry) collSecurityAccessDbEntrys.get(i)).save(con);
                }
            }
                          alreadyInSave = false;
        }
      }


                          
      /**
     * Set the PrimaryKey using ObjectKey.
     *
     * @param  id ObjectKey
     */
    public void setPrimaryKey(ObjectKey key)
        throws TorqueException
    {
            setId(((NumberKey) key).longValue());
        }

    /**
     * Set the PrimaryKey using a String.
     *
     * @param key
     */
    public void setPrimaryKey(String key) throws TorqueException
    {
            setId(Long.parseLong(key));
        }

  
    /**
     * returns an id that differentiates this object from others
     * of its class.
     */
    public ObjectKey getPrimaryKey()
    {
          return SimpleKey.keyFor(getId());
      }

 

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
       * It then fills all the association collections and sets the
     * related objects to isNew=true.
       */
      public SecurityDbEntry copy() throws TorqueException
    {
        return copyInto(new SecurityDbEntry());
    }
  
    protected SecurityDbEntry copyInto(SecurityDbEntry copyObj) throws TorqueException
    {
          copyObj.setId(id);
          copyObj.setName(name);
          copyObj.setTitle(title);
          copyObj.setDescription(description);
  
                    copyObj.setId(0);
                              
                                      
                
        List v = getSecurityAccessDbEntrys();
        for (int i = 0; i < v.size(); i++)
        {
            SecurityAccessDbEntry obj = (SecurityAccessDbEntry) v.get(i);
            copyObj.addSecurityAccessDbEntry(obj.copy());
        }
                    
        return copyObj;
    }

    /**
     * returns a peer instance associated with this om.  Since Peer classes
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     */
    public SecurityDbEntryPeer getPeer()
    {
        return peer;
    }

    public String toString()
    {
        StringBuffer str = new StringBuffer();
        str.append("SecurityDbEntry:\n");
        str.append("Id = ")
           .append(getId())
           .append("\n");
        str.append("Name = ")
           .append(getName())
           .append("\n");
        str.append("Title = ")
           .append(getTitle())
           .append("\n");
        str.append("Description = ")
           .append(getDescription())
           .append("\n");
        return(str.toString());
    }
}
